Subject: [rtcweb] JSEP Direction in offers.

From: Andy Hutton <[email-masked]>
Date: Wed, 27 Jul 2016 15:22:05 +0100

https://tools.ietf.org/html/draft-ietf-rtcweb-jsep-15#section-5.2.4 states:

"[RFC3264] direction attributes (defined in Section 6.1) in offers
are chosen according to the states of the RtpSender and RtpReceiver of
a given RtpTransceiver"

I spent some time thinking about this and trying to work out whether it
worked for re-offers and my conclusion is that the above statement is not
strictly correct but hopefully this is not a  big problem. It all depends
on what the above statement means by "the states of the
RtpSender/Receiver". My understanding is that to change the direction an
application calls setDirection() on the transceiver before createOffer and
this would cause the direction to be set accordingly in the offer but
actually the RTCRtpTransceiverDirection does not change until setLocal or
setRemote is called.

Would it make sense to change the statement in 5.2.4 to:

"[RFC3264] direction attributes (defined in Section 6.1) in offers
are chosen according to the currently preferred direction requested using
setDirection() or if no change is requested the current direction of the
RtpTransceiver"

Regards
Andy

---

From: Bernard Aboba <[email-masked]>
Date: Wed, 27 Jul 2016 08:15:58 -0700

This text needs to be revised to reflect the operation of the setDirection API. In particular, neither RtpReceiver nor RtpSender have a state attribute as referred to in this text.

See the slides from the last WebRTC WG virtual interim (starting at slide 19):
https://www.w3.org/2011/04/webrtc/wiki/images/1/12/WebRTCWG-2016-06-28.pdf

> On Jul 27, 2016, at 7:22 AM, Andy Hutton <[email-masked]> wrote:
> 
> 
> "[RFC3264] direction attributes (defined in Section 6.1) in offers are chosen according to the states of the RtpSender and RtpReceiver of a given RtpTransceiver"
> 
> I spent some time thinking about this and trying to work out whether it worked for re-offers and my conclusion is that the above statement is not strictly correct but hopefully this is not a  big problem. It all depends on what the above statement means by "the states of the RtpSender/Receiver". My understanding is that to change the direction an application calls setDirection() on the transceiver before createOffer and this would cause the direction to be set accordingly in the offer but actually the RTCRtpTransceiverDirection does not change until setLocal or setRemote is called.  
> 
> "[RFC3264] direction attributes (defined in Section 6.1) in offers are chosen according to the currently preferred direction requested using setDirection() or if no change is requested the current direction of the RtpTransceiver"
> 
> Regards
> Andy
> _______________________________________________
> rtcweb mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtcweb